\]// ImageProcessingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImageProcessing.h"
#include "ImageProcessingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CImageProcessingDlg dialog




CImageProcessingDlg::CImageProcessingDlg(CWnd* pParent /*=NULL*/)
: CDialog(CImageProcessingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImageProcessingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CImageProcessingDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_IMAGELOAD, &CImageProcessingDlg::OnBnClickedImageload)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()

	ON_BN_CLICKED(IDC_MESHSET, &CImageProcessingDlg::OnBnClickedMeshset)
	ON_BN_CLICKED(IDC_APPLY, &CImageProcessingDlg::OnBnClickedApply)
	ON_BN_CLICKED(IDC_MESHFORMAT, &CImageProcessingDlg::OnBnClickedMeshformat)
	ON_BN_CLICKED(IDC_SCRMESH1, &CImageProcessingDlg::OnBnClickedScrmesh1)
	ON_BN_CLICKED(IDC_SCRMESH2, &CImageProcessingDlg::OnBnClickedScrmesh2)
	ON_BN_CLICKED(IDC_DESTMESH1, &CImageProcessingDlg::OnBnClickedDestmesh1)
	ON_BN_CLICKED(IDC_DESTMESH2, &CImageProcessingDlg::OnBnClickedDestmesh2)
	ON_BN_CLICKED(IDC_MESHSAVE, &CImageProcessingDlg::OnBnClickedMeshsave)
	ON_BN_CLICKED(IDC_MESHLOAD, &CImageProcessingDlg::OnBnClickedMeshload)
	ON_BN_CLICKED(IDC_IMAGESAVE, &CImageProcessingDlg::OnBnClickedImagesave)
	ON_BN_CLICKED(IDC_POWER1, &CImageProcessingDlg::OnBnClickedPower1)
	ON_BN_CLICKED(IDC_POWER2, &CImageProcessingDlg::OnBnClickedPower2)
	ON_BN_CLICKED(IDC_POWER3, &CImageProcessingDlg::OnBnClickedPower3)
	ON_BN_CLICKED(IDC_POWER4, &CImageProcessingDlg::OnBnClickedPower4)
	ON_BN_CLICKED(IDC_VIEWER, &CImageProcessingDlg::OnBnClickedViewer)
END_MESSAGE_MAP()


// CImageProcessingDlg message handlers

BOOL CImageProcessingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CImageProcessingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CImageProcessingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//////////////////////////////////////////////////////////////////////////////////////
//   ۾.
//////////////////////////////////////////////////////////////////////////////////////
int CImageProcessingDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	m_isMouseMove = false;
	m_isMeshInit = true;
	m_pMeshWarp = new CMeshWarp;
	m_ScrMesh = new MESHPOINT[MeshSizeX * MeshSizeY]; 
	m_DestMesh = new MESHPOINT[MeshSizeX * MeshSizeY];

	for(int j=0; j < MeshSizeY; j++)
	{
		for(int i=0; i < MeshSizeX; i++)
		{
			MESHPOINT pt = {i*100, j*100, false};
			m_DestMesh[j*MeshSizeY + i] = m_ScrMesh[j*MeshSizeY + i] = pt;
		}
	}

	return 0;
}

void CImageProcessingDlg::OnBnClickedMeshformat()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	((CButton*)GetDlgItem(IDC_SCRMESH1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_SCRMESH2))->SetCheck(0);
	
	((CButton*)GetDlgItem(IDC_DESTMESH1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_DESTMESH2))->SetCheck(0);
	
	((CButton*)GetDlgItem(IDC_TRACKING1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TRACKING2))->SetCheck(1);

	((CButton*)GetDlgItem(IDC_POWER1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_POWER2))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_POWER3))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_POWER4))->SetCheck(0);
	m_power = 0;

	((CButton*)GetDlgItem(IDC_DMODIFY1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_DMODIFY2))->SetCheck(1);
	
	((CButton*)GetDlgItem(IDC_SRCIMAGE1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_SRCIMAGE2))->SetCheck(1);

	for(int j=0; j<MeshSizeY; j++)
	{
		for(int i=0; i<MeshSizeX; i++)
		{
			MESHPOINT pt = {i* m_EdgeWidth, j*m_EdgeHeight, false};
			m_DestMesh[j*MeshSizeY + i] = m_ScrMesh[j*MeshSizeY + i] = pt;
		}
	}
	m_isMeshInit = true;
	
	this->Invalidate();
}

//////////////////////////////////////////////////////////////////////////////////////
// ȭ ºκ
//////////////////////////////////////////////////////////////////////////////////////
void CImageProcessingDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		//  ϴ 
		if(((CButton*)GetDlgItem(IDC_SRCIMAGE1))->GetCheck())
		{
			if ( !m_SrcImage.IsNull() )
			{
				m_SrcImage.AlphaBlend(dc,0, 0, m_ImageWidth << m_power, m_ImageHeight << m_power,
					0, 0, m_ImageWidth, m_ImageHeight, 128);
			}
			if ( !m_ViewImage.IsNull() )
			{
				m_ViewImage.AlphaBlend(dc,0, 0, m_ImageWidth << m_power, m_ImageHeight << m_power,
					0, 0, m_ImageWidth, m_ImageHeight, 128);
				
				CString msg;
				msg.Format(L"׸ũ %d x %d  꿡  ڵ  : %d",m_ImageWidth, m_ImageHeight, ComputeCount);

				dc.TextOut(15,360,msg);
			}
		}
		else if( !m_ViewImage.IsNull() )
		{
			m_ViewImage.Draw(dc,0, 0, m_ImageWidth << m_power, m_ImageHeight << m_power,
					0, 0, m_ImageWidth, m_ImageHeight);
		
			CString msg;
			msg.Format(L"׸ũ %d x %d  꿡  ڵ  : %d",m_ImageWidth, m_ImageHeight, ComputeCount);

			dc.TextOut(15,415,msg);
		}

		// ޽ ׸..

		//    
		if(((CButton*)GetDlgItem(IDC_SCRMESH1))->GetCheck())
		{
			CBrush brush(RGB(0,255,0));
			dc.SelectObject(&brush);

			for(int j=0; j<MeshSizeY; j++)
			{
				for(int i=0; i<MeshSizeX; i++)
				{
					if(i < MeshSizeX-1)
					{
						dc.MoveTo(m_ScrMesh[j*MeshSizeY + i].x  << m_power, m_ScrMesh[j*MeshSizeY + i].y << m_power);
						dc.LineTo(m_ScrMesh[j*MeshSizeY + i+1].x << m_power, m_ScrMesh[j*MeshSizeY + i+1].y << m_power);
					}
					if(j < MeshSizeY-1)
					{
						dc.MoveTo(m_ScrMesh[j*MeshSizeY + i].x << m_power, m_ScrMesh[j*MeshSizeY + i].y << m_power);
						dc.LineTo(m_ScrMesh[(j+1)*MeshSizeY + i].x << m_power, m_ScrMesh[(j+1)*MeshSizeY + i].y << m_power);
					}
					// ܰ ޽ ϰ Ҽ ִ 簢 ׷ش.
					if(i && j && i<MeshSizeX-1 && j<MeshSizeY-1)
						dc.Ellipse((m_ScrMesh[j*MeshSizeY + i].x << m_power)-5, (m_ScrMesh[j*MeshSizeY + i].y << m_power)-5, 
									(m_ScrMesh[j*MeshSizeY + i].x << m_power)+5, (m_ScrMesh[j*MeshSizeY + i].y << m_power)+5);
				}
			}
		}
		//   Ȯ  
		if(((CButton*)GetDlgItem(IDC_DESTMESH1))->GetCheck())
		{
			if(m_isMeshInit == false)
			{
				CBrush brush(RGB(255,0,0));
				dc.SelectObject(&brush);

				for(int j=0; j<MeshSizeY; j++)
				{
					for(int i=0; i<MeshSizeX; i++)
					{
						if(i < MeshSizeX-1)
						{
							dc.MoveTo(m_DestMesh[j*MeshSizeY + i].x << m_power, m_DestMesh[j*MeshSizeY + i].y << m_power);
							dc.LineTo(m_DestMesh[j*MeshSizeY + i+1].x << m_power, m_DestMesh[j*MeshSizeY + i+1].y << m_power);
						}
						if(j < MeshSizeY-1)
						{
							dc.MoveTo(m_DestMesh[j*MeshSizeY + i].x << m_power, m_DestMesh[j*MeshSizeY + i].y << m_power);
							dc.LineTo(m_DestMesh[(j+1)*MeshSizeY + i].x << m_power, m_DestMesh[(j+1)*MeshSizeY + i].y << m_power);
						}
						// ܰ ޽ ϰ Ҽ ִ 簢 ׷ش.
						if(i && j && i<MeshSizeX-1 && j<MeshSizeY-1)
							dc.Ellipse((m_DestMesh[j*MeshSizeY + i].x << m_power)-5, (m_DestMesh[j*MeshSizeY + i].y << m_power)-5, 
										(m_DestMesh[j*MeshSizeY + i].x << m_power)+5, (m_DestMesh[j*MeshSizeY + i].y << m_power)+5);
					}
				}
			}
		}

		if(((CButton*)GetDlgItem(IDC_TRACKING1))->GetCheck())
		{
			CString msg;
			msg.Format(L"콺 ġ : %d, %d",
				m_NowMousePos.x, m_NowMousePos.y);
			dc.TextOut(15,435,msg);
			
			GetFaceCoordnates();
			msg.Format(L"Ʈŷ ġ : % d, %d", m_TrackingPos.x, m_TrackingPos.y);
			dc.TextOut(15,450,msg);
			
		}

		CDialog::OnPaint();
	}
}

//////////////////////////////////////////////////////////////////////////////////////
//   Լ
//////////////////////////////////////////////////////////////////////////////////////
void CImageProcessingDlg::OnBnClickedImageload()
{
	// TODO: Add your control notification handler code here
	// Get image file name
	CString szFilter = L"Image Files(*.BMP, *.GIF, *.JPG, *.PNG) | *.BMP;*.GIF;*.JPG;*.PNG; | All Files(*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);
	if(IDOK != dlg.DoModal()) return;
	CString sFilename = dlg.GetPathName();

	// Detaches the bitmap from the CImage object and destroys the bitmap if image already loaded
	CImage image;
	image.Load(sFilename);

	if ( !m_SrcImage.IsNull() )
	{
		m_SrcImage.Destroy();
	}
	m_SrcImage.Load(sFilename);

	if ( !m_ViewImage.IsNull() )
	{
		m_ViewImage.Destroy();
	}
	//m_ViewImage->Create(m_SrcImage->GetWidth(), m_SrcImage->GetHeight(), m_SrcImage->GetBPP());
	m_ViewImage.Load(sFilename);
	
	m_ImageWidth = m_SrcImage.GetWidth();
	m_ImageHeight =  m_SrcImage.GetHeight();

	m_EdgeWidth = m_ImageWidth / (MeshNumber-1);
	m_EdgeHeight= m_ImageHeight / (MeshNumber-1);

	OnBnClickedMeshformat();	
	
	m_nFilterLoad = dlg.m_ofn.nFilterIndex;
	Invalidate();
}


//  ִ° ׳  ؼ MSDN CImage  ҽ, SimpleImage  SaveԼ copy and phase 
void CImageProcessingDlg::OnBnClickedImagesave()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString strFilter;
	CSimpleArray<GUID> aguidFileTypes;
	HRESULT hResult;


	strFilter = L"Bitmap image|*.bmp|JPEG image|*.jpg|GIF image|*.gif|PNG image|*.png||";

	CFileDialog dlg(FALSE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXPLORER,strFilter);
	dlg.m_ofn.nFilterIndex = m_nFilterLoad;
	hResult = (int)dlg.DoModal();
	if (FAILED(hResult)) {
		return;
	}

    // Add the appropriate extension if the user didn't type one

	CString strFileName;
	CString strExtension;

	strFileName = dlg.m_ofn.lpstrFile;


	// add the file extension if the user didn't supply one
	if (dlg.m_ofn.nFileExtension == 0) 
	{
		switch (dlg.m_ofn.nFilterIndex)
		{
		case 1:
			strExtension = L"bmp";
			break;
		case 2:
			strExtension = L"jpg";
			break;
		case 3:
			strExtension = L"gif";
			break;
		case 4:
			strExtension = L"png";
			break;
		default:
			break;
		}

		strFileName = strFileName + '.' + strExtension;

	}

	// the extension on the file name will determine the file type that is saved
	hResult = m_ViewImage.Save(strFileName);
	if (FAILED(hResult)) {
		CString fmt;
		fmt.Format(L"Save image failed:\n%x - %s", hResult, _com_error(hResult).ErrorMessage());
		::AfxMessageBox(fmt);
		return;
	}

}

//  ޽  ޽    ε
void CImageProcessingDlg::OnBnClickedMeshload()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	LPCTSTR szFileFilter = L"޽  (*.m) | *.m||";

	CFileDialog dlg(TRUE, L"m", L"*.m", 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFileFilter);

	if(dlg.DoModal() == IDOK)
	{
		CFile file;
		CFileException e;
		if(!file.Open(dlg.GetFileName(), CFile::modeRead, &e))
		{
			e.ReportError();
			return;
		}

		// ׸ũ⸦ 256x256 Ϸ   short ƴ byte Ÿ .
		short Data[MeshSizeX * MeshSizeX * 4];
		file.Read(Data, sizeof(short) * MeshSizeX * MeshSizeX * 4);
		
		int k = 0;
		
		for(int j=0; j<MeshSizeY; j++)
		{
			for(int i=0; i<MeshSizeX; i++)
			{
				int l = j*MeshSizeY + i;

				m_ScrMesh[l].x  = Data[k++];
				m_ScrMesh[l].y  = Data[k++];
				m_DestMesh[l].x = Data[k++];
				m_DestMesh[l].y = Data[k++];
			}
		}
	}
	m_isMeshInit = false;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedMeshsave()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CFile file;
	CFileException e;

	LPCTSTR szFileFilter = L"޽  (*.m) | *.m||";

	CFileDialog dlg(FALSE, L"m", L"*.m", 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFileFilter);

	if(dlg.DoModal() == IDOK)
	{
		if(!file.Open(dlg.GetFileName(), CFile::modeWrite | CFile::modeCreate, &e))
		{
			e.ReportError();
			return;
		}

		// ׸ũ⸦ 256x256 Ϸ   short ƴ byte Ÿ .
		short Data[MeshSizeX * MeshSizeX * 4];
		
		int k = 0;
		
		for(int j=0; j<MeshSizeY; j++)
		{
			for(int i=0; i<MeshSizeX; i++)
			{
				int l = j*MeshSizeY + i;

				Data[k++] = m_ScrMesh[l].x;
				Data[k++] = m_ScrMesh[l].y;
				Data[k++] = m_DestMesh[l].x;
				Data[k++] = m_DestMesh[l].y;
			}
		}
		
		//    
		file.Write(Data, sizeof(short) * MeshSizeX * MeshSizeX * 4);
	}
}

//////////////////////////////////////////////////////////////////////////////////////
// 콺 ۾
//////////////////////////////////////////////////////////////////////////////////////
void CImageProcessingDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	//  ܰ ޽ ǵ帮 ʴ´.
	MESHPOINT pt = {point.x << m_power, point.y << m_power, true};

	//  ̹ ʱ  ޽
	if(m_isMeshInit)
	{
		//ƮŰ  ?
		if(GetKeyState(VK_CONTROL) < 0) 
		{
			
		}
		for(int j=1; j<MeshSizeY-1; j++)
		{
			for(int i=1; i<MeshSizeX-1; i++)
			{
				if((point.x >= (m_ScrMesh[j*MeshSizeY + i].x << m_power)-5 && point.x <= (m_ScrMesh[j*MeshSizeY + i].x << m_power) + 5) &&
					(point.y >= (m_ScrMesh[j*MeshSizeY + i].y << m_power)-5 && point.y <= (m_ScrMesh[j*MeshSizeY + i].y << m_power) + 5))
				{
					MESHPOINT selectPt = {i,j,true};

					m_ScrMesh[j*MeshSizeY + i].x = pt.x >> m_power;
					m_ScrMesh[j*MeshSizeY + i].y = pt.y >> m_power;
					m_ScrMesh[j*MeshSizeY + i].pick = true;

					m_PickPoint = selectPt;
					m_isMouseMove = true;
					break;
				}
			}
		}
	}
	//   ̹  ޽
	else
	{
		for(int j=1; j<MeshSizeY-1; j++)
		{
			for(int i=1; i<MeshSizeX-1; i++)
			{
				if((point.x >= (m_DestMesh[j*MeshSizeY + i].x << m_power)-5 && point.x <= (m_DestMesh[j*MeshSizeY + i].x << m_power) + 5) &&
					(point.y >= (m_DestMesh[j*MeshSizeY + i].y << m_power)-5 && point.y <= (m_DestMesh[j*MeshSizeY + i].y << m_power) + 5))
				{
					MESHPOINT selectPt = {i,j,true};

					m_DestMesh[j*MeshSizeY + i].x = pt.x >> m_power;
					m_DestMesh[j*MeshSizeY + i].y = pt.y >> m_power;
					m_DestMesh[j*MeshSizeY + i].pick = true;
					m_PickPoint = selectPt;
					m_isMouseMove = true;
					break;
				}
			}
		}
	}

	CDialog::OnLButtonDown(nFlags, point);
}

void CImageProcessingDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	MESHPOINT pt = {point.x, point.y, true};
	m_NowMousePos = pt;
	// ޽ ϶ ۾ó
	if(m_isMouseMove)
	{
		point.x -= 5;
		point.y -= 5;

		if(m_isMeshInit)
		{
			m_ScrMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_ScrMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_ScrMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = true;
		}
		else
		{
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = true;
		}

		if(!m_isMeshInit && ((CButton*)GetDlgItem(IDC_DMODIFY1))->GetCheck())
			OnBnClickedApply();
		
		this->Invalidate();
	}	
	else
		this->InvalidateRect(CRect(15,435,200,470));

	CDialog::OnMouseMove(nFlags, point);
}


void CImageProcessingDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	MESHPOINT pt = {point.x, point.y, false};

	if(m_isMouseMove)
	{
		m_isMouseMove = false;

		point.x -= 5;
		point.y -= 5;

		if(m_isMeshInit)
		{
			m_ScrMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_ScrMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_ScrMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = false;
		}
		else
		{
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = false;
		}
		this->Invalidate();
	}

	CDialog::OnLButtonUp(nFlags, point);
}

//////////////////////////////////////////////////////////////////////////////////////
//  ο ʿ ޼ҵ..
//////////////////////////////////////////////////////////////////////////////////////
// α ϴ°. 
void CImageProcessingDlg::OnBnClickedMeshset()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_isMeshInit = false;
	for(int j=0; j<MeshSizeY; j++)
	{
		for(int i=0; i<MeshSizeX; i++)
		{
			m_DestMesh[j*MeshSizeY + i] = m_ScrMesh[j*MeshSizeY + i];
		}
	}
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedApply()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if(m_isMeshInit)
	{
		MessageBox(L"޽ ϰ Ұ",L"?",MB_OK);
	}
	else
	{
		ComputeCount = 0;

		CImage src, dest;
		int w = m_ImageWidth;
		int h = m_ImageHeight;
		// Copy source
		src.Create(w, h, m_SrcImage.GetBPP());
		
		// ̰   CImage ׸ 
		// .BitBlt(CImageDC, ġ)
		// ׸ ݵ CImages ReleaseDC .
		m_SrcImage.BitBlt(src.GetDC(), 0, 0);
		src.ReleaseDC();
		
		// Mesh Warping
		m_pMeshWarp->MeshWarp(&src, &dest, m_ScrMesh, m_DestMesh, MeshSizeX, MeshSizeY);

		// Median Filtering
//		m_pMeshWarp->MedianFilter(&dest, &src, 3);

		src.BitBlt(m_ViewImage.GetDC(), 0, 0);
		m_ViewImage.ReleaseDC();

		this->Invalidate();
	}
}

void CImageProcessingDlg::GetFaceCoordnates()
{
	if(m_NowMousePos.x >= 0 && m_NowMousePos.x <= m_ImageWidth &&
		m_NowMousePos.y >= 0 && m_NowMousePos.y <= m_ImageHeight)
	{
		MESHPOINT temp;
		temp.x = m_ImageWidth / 3;
		temp.y = m_ImageHeight / 3;

		m_TrackingPos.x = m_NowMousePos.x / temp.x;
		m_TrackingPos.y = m_NowMousePos.y / temp.y;
	}
}

//////////////////////////////////////////////////////////////////////////////////////
//  ư  ɼ κ
//////////////////////////////////////////////////////////////////////////////////////
// ޽ ׸ on off  簻.
void CImageProcessingDlg::OnBnClickedScrmesh1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedScrmesh2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedDestmesh1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedDestmesh2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

// ￡  ڰ ø.  Ʈ ų .
void CImageProcessingDlg::OnBnClickedPower1()
{
	// TODO: Add your control notification handler code here
	m_power = 0;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedPower2()
{
	// TODO: Add your control notification handler code here
	m_power = 1;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedPower3()
{
	// TODO: Add your control notification handler code here
	m_power = 2;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedPower4()
{
	// TODO: Add your control notification handler code here
	m_power = 3;
	this->Invalidate();
}

// ǽð ̴ ...
void CImageProcessingDlg::OnBnClickedViewer()
{
	// TODO: Add your control notification handler code here
}
